#lang scheme

;; <pat>  = <string> | (or <pat> <pat>) | (* <pat>) | (+ <pat>) | (? <pat>)

(define (rx pats in pos)
  (if (null? pats)
      (and (= pos (string-length in))
           pos)
      (let ([pat (car pats)])
        (cond
          [(string? pat)
           (let ([len (string-length pat)])
             (and (>= (string-length in) (+ pos len))
                  (substring=? pat in pos (+ pos len))
                  (rx (cdr pats) in (+ pos len))))]
          [else
           (case (car pat)
             [(or)
              (or (rx (cons (cadr pat) (cdr pats)) in pos)
                  (rx (cons (caddr pat) (cdr pats)) in pos))]
             [(*)
              (or (rx (cons (cadr pat) pats) in pos)
                  (rx (cdr pats) in pos))]
             [(+)
              (rx (cons (cadr pat)
                        (cons (list '* (cadr pat))
                              (cdr pats)))
                  in pos)]
             [(?)
              (rx (cons (list 'or (cadr pat) "")
                        (cdr pats))
                  in pos)]
             [else
              (error "bad pattern")])]))))

(define (substring=? pat in start end)
  (for/and ([i (in-range start end)]
            [j (in-naturals)])
    (char=? (string-ref pat j) (string-ref in i))))

(rx '("a" (* "b") (or (? "c") (+ "d"))) "abbc" 0)

(let ([in (string-append "abb" (make-string 1000000 #\d))])
  (time
   (rx '("a" (* "b") (or (? "c") (+ "d"))) in 0)))
